/* cairo-utils.c generated by valac 0.36.3, the Vala compiler
 * generated from cairo-utils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Marco Trevisan <marco.trevisan@canonical.com>
 *          Mirco "MacSlow" Mueller <mirco.mueller@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR (cairo_utils_exponential_blur_get_type ())
#define CAIRO_UTILS_EXPONENTIAL_BLUR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlur))
#define CAIRO_UTILS_EXPONENTIAL_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlurClass))
#define CAIRO_UTILS_IS_EXPONENTIAL_BLUR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR))
#define CAIRO_UTILS_IS_EXPONENTIAL_BLUR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR))
#define CAIRO_UTILS_EXPONENTIAL_BLUR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlurClass))

typedef struct _CairoUtilsExponentialBlur CairoUtilsExponentialBlur;
typedef struct _CairoUtilsExponentialBlurClass CairoUtilsExponentialBlurClass;
typedef struct _CairoUtilsExponentialBlurPrivate CairoUtilsExponentialBlurPrivate;
typedef struct _CairoUtilsParamSpecExponentialBlur CairoUtilsParamSpecExponentialBlur;

struct _CairoUtilsExponentialBlur {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CairoUtilsExponentialBlurPrivate * priv;
};

struct _CairoUtilsExponentialBlurClass {
	GTypeClass parent_class;
	void (*finalize) (CairoUtilsExponentialBlur *self);
};

struct _CairoUtilsParamSpecExponentialBlur {
	GParamSpec parent_instance;
};


static gpointer cairo_utils_exponential_blur_parent_class = NULL;

void cairo_utils_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
gpointer cairo_utils_exponential_blur_ref (gpointer instance);
void cairo_utils_exponential_blur_unref (gpointer instance);
GParamSpec* cairo_utils_param_spec_exponential_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void cairo_utils_value_set_exponential_blur (GValue* value, gpointer v_object);
void cairo_utils_value_take_exponential_blur (GValue* value, gpointer v_object);
gpointer cairo_utils_value_get_exponential_blur (const GValue* value);
GType cairo_utils_exponential_blur_get_type (void) G_GNUC_CONST;
enum  {
	CAIRO_UTILS_EXPONENTIAL_BLUR_DUMMY_PROPERTY
};
#define CAIRO_UTILS_EXPONENTIAL_BLUR_APREC 16
#define CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC 7
void cairo_utils_exponential_blur_surface (cairo_surface_t* surface, gint radius);
static void cairo_utils_exponential_blur_blur (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint radius);
static void cairo_utils_exponential_blur_blurrow (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint line, gint alpha);
static void cairo_utils_exponential_blur_blurcol (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint x, gint alpha);
static void cairo_utils_exponential_blur_blurinner (guchar* pixel, gint alpha, gint* zR, gint* zG, gint* zB, gint* zA);
CairoUtilsExponentialBlur* cairo_utils_exponential_blur_new (void);
CairoUtilsExponentialBlur* cairo_utils_exponential_blur_construct (GType object_type);
static void cairo_utils_exponential_blur_finalize (CairoUtilsExponentialBlur * obj);


void cairo_utils_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius) {
	gdouble w = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble h = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble kappa = 0.0;
	gdouble _tmp4_;
	cairo_t* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_if_fail (c != NULL);
#line 27 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = width;
#line 27 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = radius;
#line 27 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	w = _tmp0_ - (_tmp1_ * 2);
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp2_ = height;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp3_ = radius;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	h = _tmp2_ - (_tmp3_ * 2);
#line 29 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp4_ = radius;
#line 29 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	kappa = 0.5522847498 * _tmp4_;
#line 30 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp5_ = c;
#line 30 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp6_ = x;
#line 30 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp7_ = radius;
#line 30 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp8_ = y;
#line 30 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_move_to (_tmp5_, _tmp6_ + _tmp7_, _tmp8_);
#line 31 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp9_ = c;
#line 31 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_line_to (_tmp9_, w, (gdouble) 0);
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp10_ = c;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp11_ = radius;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp12_ = radius;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp13_ = radius;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp14_ = radius;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_curve_to (_tmp10_, kappa, (gdouble) 0, _tmp11_, _tmp12_ - kappa, _tmp13_, _tmp14_);
#line 33 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp15_ = c;
#line 33 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_line_to (_tmp15_, (gdouble) 0, h);
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp16_ = c;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp17_ = radius;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp18_ = radius;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp19_ = radius;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp20_ = radius;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_curve_to (_tmp16_, (gdouble) 0, kappa, kappa - _tmp17_, _tmp18_, -_tmp19_, _tmp20_);
#line 35 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp21_ = c;
#line 35 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_line_to (_tmp21_, -w, (gdouble) 0);
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp22_ = c;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp23_ = radius;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp24_ = radius;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp25_ = radius;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp26_ = radius;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_curve_to (_tmp22_, -kappa, (gdouble) 0, -_tmp23_, kappa - _tmp24_, -_tmp25_, -_tmp26_);
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp27_ = c;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_line_to (_tmp27_, (gdouble) 0, -h);
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp28_ = c;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp29_ = radius;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp30_ = radius;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp31_ = radius;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp32_ = radius;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_rel_curve_to (_tmp28_, (gdouble) 0, -kappa, _tmp29_ - kappa, -_tmp30_, _tmp31_, -_tmp32_);
#line 215 "cairo-utils.c"
}


void cairo_utils_exponential_blur_surface (cairo_surface_t* surface, gint radius) {
	gint _tmp0_;
	cairo_surface_t* _tmp1_;
	guchar* pixels = NULL;
	cairo_surface_t* _tmp2_;
	guchar* _tmp3_;
	gint pixels_length1;
	gint _pixels_size_;
	gint width = 0;
	cairo_surface_t* _tmp4_;
	gint _tmp5_;
	gint height = 0;
	cairo_surface_t* _tmp6_;
	gint _tmp7_;
	cairo_format_t format = 0;
	cairo_surface_t* _tmp8_;
	cairo_format_t _tmp9_;
	cairo_format_t _tmp10_;
	cairo_surface_t* _tmp23_;
#line 48 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_if_fail (surface != NULL);
#line 50 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = radius;
#line 50 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (_tmp0_ < 1) {
#line 51 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		return;
#line 246 "cairo-utils.c"
	}
#line 54 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = surface;
#line 54 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_surface_flush (_tmp1_);
#line 56 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp2_ = surface;
#line 56 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp3_ = cairo_image_surface_get_data (_tmp2_);
#line 56 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	pixels = _tmp3_;
#line 56 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	pixels_length1 = -1;
#line 56 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_pixels_size_ = pixels_length1;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp4_ = surface;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp5_ = cairo_image_surface_get_width (_tmp4_);
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	width = _tmp5_;
#line 58 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp6_ = surface;
#line 58 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp7_ = cairo_image_surface_get_height (_tmp6_);
#line 58 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	height = _tmp7_;
#line 59 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp8_ = surface;
#line 59 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp9_ = cairo_image_surface_get_format (_tmp8_);
#line 59 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	format = _tmp9_;
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp10_ = format;
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	switch (_tmp10_) {
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		case CAIRO_FORMAT_ARGB32:
#line 286 "cairo-utils.c"
		{
			guchar* _tmp11_;
			gint _tmp11__length1;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp11_ = pixels;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp11__length1 = pixels_length1;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp12_ = width;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp13_ = height;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp14_ = radius;
#line 64 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			cairo_utils_exponential_blur_blur (_tmp11_, _tmp11__length1, _tmp12_, _tmp13_, 4, _tmp14_);
#line 65 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			break;
#line 307 "cairo-utils.c"
		}
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		case CAIRO_FORMAT_RGB24:
#line 311 "cairo-utils.c"
		{
			guchar* _tmp15_;
			gint _tmp15__length1;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp15_ = pixels;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp15__length1 = pixels_length1;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp16_ = width;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp17_ = height;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp18_ = radius;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			cairo_utils_exponential_blur_blur (_tmp15_, _tmp15__length1, _tmp16_, _tmp17_, 3, _tmp18_);
#line 69 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			break;
#line 332 "cairo-utils.c"
		}
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		case CAIRO_FORMAT_A8:
#line 336 "cairo-utils.c"
		{
			guchar* _tmp19_;
			gint _tmp19__length1;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp19_ = pixels;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp19__length1 = pixels_length1;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp20_ = width;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp21_ = height;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp22_ = radius;
#line 72 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			cairo_utils_exponential_blur_blur (_tmp19_, _tmp19__length1, _tmp20_, _tmp21_, 1, _tmp22_);
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			break;
#line 357 "cairo-utils.c"
		}
		default:
		{
#line 77 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			break;
#line 363 "cairo-utils.c"
		}
	}
#line 81 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp23_ = surface;
#line 81 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_surface_mark_dirty (_tmp23_);
#line 370 "cairo-utils.c"
}


static void cairo_utils_exponential_blur_blur (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint radius) {
	gint alpha = 0;
	gint _tmp0_;
	gfloat _tmp1_;
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = radius;
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = expf ((-2.3f) / (_tmp0_ + 1.0f));
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	alpha = (gint) ((1 << CAIRO_UTILS_EXPONENTIAL_BLUR_APREC) * (1.0f - _tmp1_));
#line 384 "cairo-utils.c"
	{
		gint row = 0;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		row = 0;
#line 389 "cairo-utils.c"
		{
			gboolean _tmp2_ = FALSE;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp2_ = TRUE;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 396 "cairo-utils.c"
				gint _tmp4_;
				gint _tmp5_;
				guchar* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp2_) {
#line 408 "cairo-utils.c"
					gint _tmp3_;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp3_ = row;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					row = _tmp3_ + 1;
#line 414 "cairo-utils.c"
				}
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp2_ = FALSE;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp4_ = row;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp5_ = height;
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 92 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 426 "cairo-utils.c"
				}
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp6_ = pixels;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp6__length1 = pixels_length1;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp7_ = width;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp8_ = height;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp9_ = channels;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp10_ = row;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp11_ = alpha;
#line 93 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurrow (_tmp6_, _tmp6__length1, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 444 "cairo-utils.c"
			}
		}
	}
	{
		gint col = 0;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		col = 0;
#line 452 "cairo-utils.c"
		{
			gboolean _tmp12_ = FALSE;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp12_ = TRUE;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 459 "cairo-utils.c"
				gint _tmp14_;
				gint _tmp15_;
				guchar* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp12_) {
#line 471 "cairo-utils.c"
					gint _tmp13_;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp13_ = col;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					col = _tmp13_ + 1;
#line 477 "cairo-utils.c"
				}
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp12_ = FALSE;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp14_ = col;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp15_ = width;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 489 "cairo-utils.c"
				}
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp16_ = pixels;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp16__length1 = pixels_length1;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp17_ = width;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp18_ = height;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp19_ = channels;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp20_ = col;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp21_ = alpha;
#line 96 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurcol (_tmp16_, _tmp16__length1, _tmp17_, _tmp18_, _tmp19_, _tmp20_, _tmp21_);
#line 507 "cairo-utils.c"
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurrow (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint line, gint alpha) {
	guchar* scanline = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint zR = 0;
	guchar* _tmp4_;
	gint zG = 0;
	guchar* _tmp5_;
	gint zB = 0;
	guchar* _tmp6_;
	gint zA = 0;
	guchar* _tmp7_;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = pixels;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0__length1 = pixels_length1;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = line;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp2_ = width;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp3_ = channels;
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	scanline = &_tmp0_[(_tmp1_ * _tmp2_) * _tmp3_];
#line 103 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp4_ = scanline;
#line 103 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zR = (*_tmp4_) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 104 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp5_ = scanline;
#line 104 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zG = (*(_tmp5_ + 1)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 105 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp6_ = scanline;
#line 105 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zB = (*(_tmp6_ + 2)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 106 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp7_ = scanline;
#line 106 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zA = (*(_tmp7_ + 3)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 557 "cairo-utils.c"
	{
		gint index = 0;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		index = 0;
#line 562 "cairo-utils.c"
		{
			gboolean _tmp8_ = FALSE;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp8_ = TRUE;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 569 "cairo-utils.c"
				gint _tmp10_;
				gint _tmp11_;
				guchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp8_) {
#line 578 "cairo-utils.c"
					gint _tmp9_;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp9_ = index;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					index = _tmp9_ + 1;
#line 584 "cairo-utils.c"
				}
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp8_ = FALSE;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp10_ = index;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp11_ = width;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 596 "cairo-utils.c"
				}
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp12_ = scanline;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp13_ = index;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp14_ = channels;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp15_ = alpha;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurinner (&_tmp12_[_tmp13_ * _tmp14_], _tmp15_, &zR, &zG, &zB, &zA);
#line 608 "cairo-utils.c"
			}
		}
	}
	{
		gint index = 0;
		gint _tmp16_;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		_tmp16_ = width;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		index = _tmp16_ - 2;
#line 619 "cairo-utils.c"
		{
			gboolean _tmp17_ = FALSE;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp17_ = TRUE;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 626 "cairo-utils.c"
				gint _tmp19_;
				guchar* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp17_) {
#line 634 "cairo-utils.c"
					gint _tmp18_;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp18_ = index;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					index = _tmp18_ - 1;
#line 640 "cairo-utils.c"
				}
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp17_ = FALSE;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp19_ = index;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp19_ >= 0)) {
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 650 "cairo-utils.c"
				}
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp20_ = scanline;
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp21_ = index;
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp22_ = channels;
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp23_ = alpha;
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurinner (&_tmp20_[_tmp21_ * _tmp22_], _tmp23_, &zR, &zG, &zB, &zA);
#line 662 "cairo-utils.c"
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurcol (guchar* pixels, int pixels_length1, gint width, gint height, gint channels, gint x, gint alpha) {
	guchar* ptr = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
	gint zR = 0;
	guchar* _tmp3_;
	gint zG = 0;
	guchar* _tmp4_;
	gint zB = 0;
	guchar* _tmp5_;
	gint zA = 0;
	guchar* _tmp6_;
#line 121 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = pixels;
#line 121 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0__length1 = pixels_length1;
#line 121 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = x;
#line 121 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp2_ = channels;
#line 121 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	ptr = &_tmp0_[_tmp1_ * _tmp2_];
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp3_ = ptr;
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zR = (*_tmp3_) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 124 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp4_ = ptr;
#line 124 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zG = (*(_tmp4_ + 1)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 125 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp5_ = ptr;
#line 125 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zB = (*(_tmp5_ + 2)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 126 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp6_ = ptr;
#line 126 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	zA = (*(_tmp6_ + 3)) << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC;
#line 709 "cairo-utils.c"
	{
		gint index = 0;
		gint _tmp7_;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		_tmp7_ = width;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		index = _tmp7_;
#line 717 "cairo-utils.c"
		{
			gboolean _tmp8_ = FALSE;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp8_ = TRUE;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 724 "cairo-utils.c"
				gint _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				guchar* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp8_) {
#line 734 "cairo-utils.c"
					gint _tmp9_;
					gint _tmp10_;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp9_ = index;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp10_ = width;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					index = _tmp9_ + _tmp10_;
#line 743 "cairo-utils.c"
				}
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp8_ = FALSE;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp11_ = index;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp12_ = height;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp13_ = width;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp11_ < ((_tmp12_ - 1) * _tmp13_))) {
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 757 "cairo-utils.c"
				}
#line 130 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp14_ = ptr;
#line 130 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp15_ = index;
#line 130 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp16_ = channels;
#line 130 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp17_ = alpha;
#line 130 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurinner (&_tmp14_[_tmp15_ * _tmp16_], _tmp17_, &zR, &zG, &zB, &zA);
#line 769 "cairo-utils.c"
			}
		}
	}
	{
		gint index = 0;
		gint _tmp18_;
		gint _tmp19_;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		_tmp18_ = height;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		_tmp19_ = width;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		index = (_tmp18_ - 2) * _tmp19_;
#line 783 "cairo-utils.c"
		{
			gboolean _tmp20_ = FALSE;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			_tmp20_ = TRUE;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			while (TRUE) {
#line 790 "cairo-utils.c"
				gint _tmp23_;
				guchar* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!_tmp20_) {
#line 798 "cairo-utils.c"
					gint _tmp21_;
					gint _tmp22_;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp21_ = index;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					_tmp22_ = width;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					index = _tmp21_ - _tmp22_;
#line 807 "cairo-utils.c"
				}
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp20_ = FALSE;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp23_ = index;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				if (!(_tmp23_ >= 0)) {
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
					break;
#line 817 "cairo-utils.c"
				}
#line 135 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp24_ = ptr;
#line 135 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp25_ = index;
#line 135 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp26_ = channels;
#line 135 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				_tmp27_ = alpha;
#line 135 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
				cairo_utils_exponential_blur_blurinner (&_tmp24_[_tmp25_ * _tmp26_], _tmp27_, &zR, &zG, &zB, &zA);
#line 829 "cairo-utils.c"
			}
		}
	}
}


static void cairo_utils_exponential_blur_blurinner (guchar* pixel, gint alpha, gint* zR, gint* zG, gint* zB, gint* zA) {
	gint R = 0;
	gint G = 0;
	gint B = 0;
	guchar A = '\0';
	guchar* _tmp0_;
	guchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	guchar* _tmp16_;
	gint _tmp17_;
	guchar _tmp18_;
	guchar* _tmp19_;
	gint _tmp20_;
	guchar _tmp21_;
	guchar* _tmp22_;
	gint _tmp23_;
	guchar _tmp24_;
	guchar* _tmp25_;
	gint _tmp26_;
	guchar _tmp27_;
#line 146 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp0_ = pixel;
#line 146 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	R = (gint) (*_tmp0_);
#line 147 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp1_ = pixel;
#line 147 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	G = (gint) (*(_tmp1_ + 1));
#line 148 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp2_ = pixel;
#line 148 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	B = (gint) (*(_tmp2_ + 2));
#line 149 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp3_ = pixel;
#line 149 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	A = *(_tmp3_ + 3);
#line 151 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp4_ = *zR;
#line 151 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp5_ = alpha;
#line 151 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp6_ = *zR;
#line 151 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*zR = _tmp4_ + ((_tmp5_ * ((R << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp6_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
#line 152 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp7_ = *zG;
#line 152 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp8_ = alpha;
#line 152 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp9_ = *zG;
#line 152 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*zG = _tmp7_ + ((_tmp8_ * ((G << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp9_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
#line 153 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp10_ = *zB;
#line 153 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp11_ = alpha;
#line 153 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp12_ = *zB;
#line 153 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*zB = _tmp10_ + ((_tmp11_ * ((B << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp12_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
#line 154 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp13_ = *zA;
#line 154 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp14_ = alpha;
#line 154 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp15_ = *zA;
#line 154 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*zA = _tmp13_ + ((_tmp14_ * ((A << CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC) - _tmp15_)) >> CAIRO_UTILS_EXPONENTIAL_BLUR_APREC);
#line 156 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp16_ = pixel;
#line 156 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp17_ = *zR;
#line 156 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*_tmp16_ = (guchar) (_tmp17_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
#line 156 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp18_ = *_tmp16_;
#line 157 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp19_ = pixel;
#line 157 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp20_ = *zG;
#line 157 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*(_tmp19_ + 1) = (guchar) (_tmp20_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
#line 157 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp21_ = *(_tmp19_ + 1);
#line 158 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp22_ = pixel;
#line 158 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp23_ = *zB;
#line 158 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*(_tmp22_ + 2) = (guchar) (_tmp23_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
#line 158 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp24_ = *(_tmp22_ + 2);
#line 159 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp25_ = pixel;
#line 159 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp26_ = *zA;
#line 159 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	*(_tmp25_ + 3) = (guchar) (_tmp26_ >> CAIRO_UTILS_EXPONENTIAL_BLUR_ZPREC);
#line 159 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	_tmp27_ = *(_tmp25_ + 3);
#line 949 "cairo-utils.c"
}


CairoUtilsExponentialBlur* cairo_utils_exponential_blur_construct (GType object_type) {
	CairoUtilsExponentialBlur* self = NULL;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	self = (CairoUtilsExponentialBlur*) g_type_create_instance (object_type);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return self;
#line 959 "cairo-utils.c"
}


CairoUtilsExponentialBlur* cairo_utils_exponential_blur_new (void) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return cairo_utils_exponential_blur_construct (CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR);
#line 966 "cairo-utils.c"
}


static void cairo_utils_value_exponential_blur_init (GValue* value) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	value->data[0].v_pointer = NULL;
#line 973 "cairo-utils.c"
}


static void cairo_utils_value_exponential_blur_free_value (GValue* value) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (value->data[0].v_pointer) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		cairo_utils_exponential_blur_unref (value->data[0].v_pointer);
#line 982 "cairo-utils.c"
	}
}


static void cairo_utils_value_exponential_blur_copy_value (const GValue* src_value, GValue* dest_value) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (src_value->data[0].v_pointer) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		dest_value->data[0].v_pointer = cairo_utils_exponential_blur_ref (src_value->data[0].v_pointer);
#line 992 "cairo-utils.c"
	} else {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 996 "cairo-utils.c"
	}
}


static gpointer cairo_utils_value_exponential_blur_peek_pointer (const GValue* value) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return value->data[0].v_pointer;
#line 1004 "cairo-utils.c"
}


static gchar* cairo_utils_value_exponential_blur_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (collect_values[0].v_pointer) {
#line 1011 "cairo-utils.c"
		CairoUtilsExponentialBlur * object;
		object = collect_values[0].v_pointer;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1018 "cairo-utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1022 "cairo-utils.c"
		}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = cairo_utils_exponential_blur_ref (object);
#line 1026 "cairo-utils.c"
	} else {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = NULL;
#line 1030 "cairo-utils.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return NULL;
#line 1034 "cairo-utils.c"
}


static gchar* cairo_utils_value_exponential_blur_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	CairoUtilsExponentialBlur ** object_p;
	object_p = collect_values[0].v_pointer;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (!object_p) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1045 "cairo-utils.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (!value->data[0].v_pointer) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		*object_p = NULL;
#line 1051 "cairo-utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		*object_p = value->data[0].v_pointer;
#line 1055 "cairo-utils.c"
	} else {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		*object_p = cairo_utils_exponential_blur_ref (value->data[0].v_pointer);
#line 1059 "cairo-utils.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return NULL;
#line 1063 "cairo-utils.c"
}


GParamSpec* cairo_utils_param_spec_exponential_blur (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	CairoUtilsParamSpecExponentialBlur* spec;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR), NULL);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return G_PARAM_SPEC (spec);
#line 1077 "cairo-utils.c"
}


gpointer cairo_utils_value_get_exponential_blur (const GValue* value) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR), NULL);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return value->data[0].v_pointer;
#line 1086 "cairo-utils.c"
}


void cairo_utils_value_set_exponential_blur (GValue* value, gpointer v_object) {
	CairoUtilsExponentialBlur * old;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	old = value->data[0].v_pointer;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (v_object) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = v_object;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		cairo_utils_exponential_blur_ref (value->data[0].v_pointer);
#line 1106 "cairo-utils.c"
	} else {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = NULL;
#line 1110 "cairo-utils.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (old) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		cairo_utils_exponential_blur_unref (old);
#line 1116 "cairo-utils.c"
	}
}


void cairo_utils_value_take_exponential_blur (GValue* value, gpointer v_object) {
	CairoUtilsExponentialBlur * old;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	old = value->data[0].v_pointer;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (v_object) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = v_object;
#line 1135 "cairo-utils.c"
	} else {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		value->data[0].v_pointer = NULL;
#line 1139 "cairo-utils.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (old) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		cairo_utils_exponential_blur_unref (old);
#line 1145 "cairo-utils.c"
	}
}


static void cairo_utils_exponential_blur_class_init (CairoUtilsExponentialBlurClass * klass) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	cairo_utils_exponential_blur_parent_class = g_type_class_peek_parent (klass);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	((CairoUtilsExponentialBlurClass *) klass)->finalize = cairo_utils_exponential_blur_finalize;
#line 1155 "cairo-utils.c"
}


static void cairo_utils_exponential_blur_instance_init (CairoUtilsExponentialBlur * self) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	self->ref_count = 1;
#line 1162 "cairo-utils.c"
}


static void cairo_utils_exponential_blur_finalize (CairoUtilsExponentialBlur * obj) {
	CairoUtilsExponentialBlur * self;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAIRO_UTILS_TYPE_EXPONENTIAL_BLUR, CairoUtilsExponentialBlur);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_signal_handlers_destroy (self);
#line 1172 "cairo-utils.c"
}


GType cairo_utils_exponential_blur_get_type (void) {
	static volatile gsize cairo_utils_exponential_blur_type_id__volatile = 0;
	if (g_once_init_enter (&cairo_utils_exponential_blur_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { cairo_utils_value_exponential_blur_init, cairo_utils_value_exponential_blur_free_value, cairo_utils_value_exponential_blur_copy_value, cairo_utils_value_exponential_blur_peek_pointer, "p", cairo_utils_value_exponential_blur_collect_value, "p", cairo_utils_value_exponential_blur_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (CairoUtilsExponentialBlurClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cairo_utils_exponential_blur_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CairoUtilsExponentialBlur), 0, (GInstanceInitFunc) cairo_utils_exponential_blur_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType cairo_utils_exponential_blur_type_id;
		cairo_utils_exponential_blur_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CairoUtilsExponentialBlur", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&cairo_utils_exponential_blur_type_id__volatile, cairo_utils_exponential_blur_type_id);
	}
	return cairo_utils_exponential_blur_type_id__volatile;
}


gpointer cairo_utils_exponential_blur_ref (gpointer instance) {
	CairoUtilsExponentialBlur * self;
	self = instance;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	return instance;
#line 1197 "cairo-utils.c"
}


void cairo_utils_exponential_blur_unref (gpointer instance) {
	CairoUtilsExponentialBlur * self;
	self = instance;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		CAIRO_UTILS_EXPONENTIAL_BLUR_GET_CLASS (self)->finalize (self);
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/cairo-utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1210 "cairo-utils.c"
	}
}



