/* toggle-box.c generated by valac 0.36.3, the Vala compiler
 * generated from toggle-box.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_TOGGLE_BOX (toggle_box_get_type ())
#define TOGGLE_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOGGLE_BOX, ToggleBox))
#define TOGGLE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOGGLE_BOX, ToggleBoxClass))
#define IS_TOGGLE_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOGGLE_BOX))
#define IS_TOGGLE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOGGLE_BOX))
#define TOGGLE_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOGGLE_BOX, ToggleBoxClass))

typedef struct _ToggleBox ToggleBox;
typedef struct _ToggleBoxClass ToggleBoxClass;
typedef struct _ToggleBoxPrivate ToggleBoxPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

#define TYPE_FLAT_BUTTON (flat_button_get_type ())
#define FLAT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAT_BUTTON, FlatButton))
#define FLAT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FLAT_BUTTON, FlatButtonClass))
#define IS_FLAT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAT_BUTTON))
#define IS_FLAT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FLAT_BUTTON))
#define FLAT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FLAT_BUTTON, FlatButtonClass))

typedef struct _FlatButton FlatButton;
typedef struct _FlatButtonClass FlatButtonClass;

#define TYPE_CACHED_IMAGE (cached_image_get_type ())
#define CACHED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CACHED_IMAGE, CachedImage))
#define CACHED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CACHED_IMAGE, CachedImageClass))
#define IS_CACHED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CACHED_IMAGE))
#define IS_CACHED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CACHED_IMAGE))
#define CACHED_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CACHED_IMAGE, CachedImageClass))

typedef struct _CachedImage CachedImage;
typedef struct _CachedImageClass CachedImageClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ToggleBox {
	GtkBox parent_instance;
	ToggleBoxPrivate * priv;
};

struct _ToggleBoxClass {
	GtkBoxClass parent_class;
};

struct _ToggleBoxPrivate {
	gchar* _default_key;
	gchar* _starting_key;
	gchar* _selected_key;
	GtkButton* selected_button;
};


static gpointer toggle_box_parent_class = NULL;

GType toggle_box_get_type (void) G_GNUC_CONST;
#define TOGGLE_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TOGGLE_BOX, ToggleBoxPrivate))
enum  {
	TOGGLE_BOX_DUMMY_PROPERTY,
	TOGGLE_BOX_DEFAULT_KEY,
	TOGGLE_BOX_STARTING_KEY,
	TOGGLE_BOX_SELECTED_KEY
};
ToggleBox* toggle_box_new (const gchar* default_key, const gchar* starting_key);
ToggleBox* toggle_box_construct (GType object_type, const gchar* default_key, const gchar* starting_key);
void toggle_box_add_item (ToggleBox* self, const gchar* key, const gchar* label, GdkPixbuf* icon);
static GtkButton* toggle_box_make_button (ToggleBox* self, const gchar* key, const gchar* name_in, GdkPixbuf* icon);
const gchar* toggle_box_get_starting_key (ToggleBox* self);
const gchar* toggle_box_get_default_key (ToggleBox* self);
static void toggle_box_select (ToggleBox* self, GtkButton* button);
static gboolean toggle_box_real_draw (GtkWidget* base, cairo_t* c);
void cairo_utils_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
#define grid_size 40
void toggle_box_set_selected_key (ToggleBox* self, const gchar* value);
GType flat_button_get_type (void) G_GNUC_CONST;
FlatButton* flat_button_new (void);
FlatButton* flat_button_construct (GType object_type);
static void toggle_box_button_clicked_cb (ToggleBox* self, GtkButton* button);
static void _toggle_box_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
GType cached_image_get_type (void) G_GNUC_CONST;
CachedImage* cached_image_new (GdkPixbuf* pixbuf);
CachedImage* cached_image_construct (GType object_type, GdkPixbuf* pixbuf);
static void toggle_box_real_grab_focus (GtkWidget* base);
static void toggle_box_set_default_key (ToggleBox* self, const gchar* value);
static void toggle_box_set_starting_key (ToggleBox* self, const gchar* value);
const gchar* toggle_box_get_selected_key (ToggleBox* self);
static GObject * toggle_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void toggle_box_finalize (GObject * obj);
static void _vala_toggle_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_toggle_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ToggleBox* toggle_box_construct (GType object_type, const gchar* default_key, const gchar* starting_key) {
	ToggleBox * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = default_key;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp1_ = starting_key;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp2_ = starting_key;
#line 28 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self = (ToggleBox*) g_object_new (object_type, "default-key", _tmp0_, "starting-key", _tmp1_, "selected-key", _tmp2_, NULL);
#line 26 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return self;
#line 142 "toggle-box.c"
}


ToggleBox* toggle_box_new (const gchar* default_key, const gchar* starting_key) {
#line 26 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return toggle_box_construct (TYPE_TOGGLE_BOX, default_key, starting_key);
#line 149 "toggle-box.c"
}


void toggle_box_add_item (ToggleBox* self, const gchar* key, const gchar* label, GdkPixbuf* icon) {
	GtkButton* item = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GdkPixbuf* _tmp2_;
	GtkButton* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GList* _tmp6_;
	GList* _tmp7_;
	gboolean _tmp8_;
	GtkButton* _tmp16_;
	GtkButton* _tmp17_;
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (key != NULL);
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (label != NULL);
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = key;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp1_ = label;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp2_ = icon;
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp3_ = toggle_box_make_button (self, _tmp0_, _tmp1_, _tmp2_);
#line 34 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	item = _tmp3_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp6_ = gtk_container_get_children ((GtkContainer*) self);
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp7_ = _tmp6_;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp8_ = _tmp7_ == NULL;
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_list_free0 (_tmp7_);
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp8_) {
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp5_ = TRUE;
#line 194 "toggle-box.c"
	} else {
		gboolean _tmp9_ = FALSE;
		const gchar* _tmp10_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp10_ = self->priv->_starting_key;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		if (_tmp10_ == NULL) {
#line 202 "toggle-box.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
			_tmp11_ = self->priv->_default_key;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
			_tmp12_ = key;
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
			_tmp9_ = g_strcmp0 (_tmp11_, _tmp12_) == 0;
#line 211 "toggle-box.c"
		} else {
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
			_tmp9_ = FALSE;
#line 215 "toggle-box.c"
		}
#line 37 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp5_ = _tmp9_;
#line 219 "toggle-box.c"
	}
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp5_) {
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp4_ = TRUE;
#line 225 "toggle-box.c"
	} else {
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp13_ = self->priv->_starting_key;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp14_ = key;
#line 38 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp4_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 235 "toggle-box.c"
	}
#line 36 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp4_) {
#line 239 "toggle-box.c"
		GtkButton* _tmp15_;
#line 39 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp15_ = item;
#line 39 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		toggle_box_select (self, _tmp15_);
#line 245 "toggle-box.c"
	}
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp16_ = item;
#line 41 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_widget_show ((GtkWidget*) _tmp16_);
#line 42 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp17_ = item;
#line 42 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
#line 32 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_object_unref0 (item);
#line 257 "toggle-box.c"
}


static gboolean toggle_box_real_draw (GtkWidget* base, cairo_t* c) {
	ToggleBox * self;
	gboolean result = FALSE;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp0_ = {0};
	cairo_t* _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	gboolean _tmp10_;
#line 52 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self = (ToggleBox*) base;
#line 52 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 55 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 55 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	allocation = _tmp0_;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp1_ = c;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp2_ = allocation;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp3_ = _tmp2_.width;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp4_ = allocation;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp5_ = _tmp4_.height;
#line 57 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	cairo_utils_rounded_rectangle (_tmp1_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp3_, (gdouble) _tmp5_, 0.1 * grid_size);
#line 59 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp6_ = c;
#line 59 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	cairo_set_source_rgba (_tmp6_, 0.5, 0.5, 0.5, 0.5);
#line 60 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp7_ = c;
#line 60 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	cairo_set_line_width (_tmp7_, (gdouble) 1);
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp8_ = c;
#line 61 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	cairo_stroke (_tmp8_);
#line 63 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp9_ = c;
#line 63 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp10_ = GTK_WIDGET_CLASS (toggle_box_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), _tmp9_);
#line 63 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	result = _tmp10_;
#line 63 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return result;
#line 316 "toggle-box.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "toggle-box.c"
}


static void toggle_box_select (ToggleBox* self, GtkButton* button) {
	GtkButton* _tmp0_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkButton* _tmp9_;
	gconstpointer _tmp10_;
#line 66 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 66 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (button != NULL);
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = self->priv->selected_button;
#line 68 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp0_ != NULL) {
#line 344 "toggle-box.c"
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkStyleContext* _tmp3_;
#line 70 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp1_ = self->priv->selected_button;
#line 70 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_button_set_relief (_tmp1_, GTK_RELIEF_NONE);
#line 71 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp2_ = self->priv->selected_button;
#line 71 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 71 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_style_context_remove_class (_tmp3_, "selected");
#line 358 "toggle-box.c"
	}
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp4_ = button;
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_object_unref0 (self->priv->selected_button);
#line 73 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self->priv->selected_button = _tmp5_;
#line 74 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp6_ = self->priv->selected_button;
#line 74 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_button_set_relief (_tmp6_, GTK_RELIEF_NORMAL);
#line 75 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp7_ = self->priv->selected_button;
#line 75 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 75 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_style_context_add_class (_tmp8_, "selected");
#line 76 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp9_ = self->priv->selected_button;
#line 76 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp10_ = g_object_get_data ((GObject*) _tmp9_, "toggle-list-key");
#line 76 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	toggle_box_set_selected_key (self, (const gchar*) _tmp10_);
#line 384 "toggle-box.c"
}


static void _toggle_box_button_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 84 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	toggle_box_button_clicked_cb ((ToggleBox*) self, _sender);
#line 391 "toggle-box.c"
}


static GtkButton* toggle_box_make_button (ToggleBox* self, const gchar* key, const gchar* name_in, GdkPixbuf* icon) {
	GtkButton* result = NULL;
	FlatButton* item = NULL;
	FlatButton* _tmp0_;
	FlatButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	FlatButton* _tmp3_;
	FlatButton* _tmp4_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp5_;
	GdkPixbuf* _tmp6_;
	gchar* name = NULL;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkBox* _tmp21_;
	FlatButton* _tmp22_;
	FlatButton* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	FlatButton* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	GError * _inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 79 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (name_in != NULL, NULL);
#line 81 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = flat_button_new ();
#line 81 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_ref_sink (_tmp0_);
#line 81 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	item = _tmp0_;
#line 82 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp1_ = item;
#line 82 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 82 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_style_context_add_class (_tmp2_, "toggle-button");
#line 83 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp3_ = item;
#line 83 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_button_set_relief ((GtkButton*) _tmp3_, GTK_RELIEF_NONE);
#line 84 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp4_ = item;
#line 84 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_signal_connect_object ((GtkButton*) _tmp4_, "clicked", (GCallback) _toggle_box_button_clicked_cb_gtk_button_clicked, self, 0);
#line 86 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 86 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_ref_sink (_tmp5_);
#line 86 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	hbox = _tmp5_;
#line 88 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp6_ = icon;
#line 88 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp6_ != NULL) {
#line 461 "toggle-box.c"
		CachedImage* image = NULL;
		GdkPixbuf* _tmp7_;
		CachedImage* _tmp8_;
		GtkBox* _tmp9_;
		CachedImage* _tmp10_;
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp7_ = icon;
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp8_ = cached_image_new (_tmp7_);
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_object_ref_sink (_tmp8_);
#line 90 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		image = _tmp8_;
#line 91 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp9_ = hbox;
#line 91 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp10_ = image;
#line 91 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_box_pack_start (_tmp9_, (GtkWidget*) _tmp10_, FALSE, FALSE, (guint) 0);
#line 88 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_object_unref0 (image);
#line 483 "toggle-box.c"
	}
#line 94 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp11_ = name_in;
#line 94 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 94 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	name = _tmp12_;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp13_ = key;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp14_ = self->priv->_default_key;
#line 95 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
#line 497 "toggle-box.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 98 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp15_ = name;
#line 98 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp16_ = g_strdup_printf (_ ("%s (Default)"), _tmp15_);
#line 98 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_free0 (name);
#line 98 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		name = _tmp16_;
#line 508 "toggle-box.c"
	}
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (NULL);
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_ref_sink (_tmp17_);
#line 101 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	label = _tmp17_;
#line 102 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp18_ = name;
#line 102 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp19_ = g_strdup_printf ("<span font=\"Ubuntu 13\">%s</span>", _tmp18_);
#line 102 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp20_ = _tmp19_;
#line 102 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_label_set_markup (label, _tmp20_);
#line 102 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_free0 (_tmp20_);
#line 103 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 104 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp21_ = hbox;
#line 104 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) label, TRUE, TRUE, (guint) 0);
#line 106 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp22_ = item;
#line 106 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, TRUE);
#line 107 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp23_ = item;
#line 107 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp24_ = hbox;
#line 107 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp25_ = hbox;
#line 108 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp25_);
#line 546 "toggle-box.c"
	{
		GtkCssProvider* style = NULL;
		GtkCssProvider* _tmp26_;
		FlatButton* _tmp27_;
		GtkStyleContext* _tmp28_;
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp26_ = gtk_css_provider_new ();
#line 113 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		style = _tmp26_;
#line 114 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_css_provider_load_from_data (style, "* {padding: 8px;}", (gssize) -1, &_inner_error_);
#line 114 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
			_g_object_unref0 (style);
#line 562 "toggle-box.c"
			goto __catch33_g_error;
		}
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp27_ = item;
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
#line 115 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_style_context_add_provider (_tmp28_, (GtkStyleProvider*) style, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_object_unref0 (style);
#line 573 "toggle-box.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		e = _inner_error_;
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp29_ = e;
#line 119 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp30_ = _tmp29_->message;
#line 119 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_debug ("toggle-box.vala:119: Internal error loading session chooser style: %s", _tmp30_);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_error_free0 (e);
#line 593 "toggle-box.c"
	}
	__finally33:
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_object_unref0 (label);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_free0 (name);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_object_unref0 (hbox);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_object_unref0 (item);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		return NULL;
#line 612 "toggle-box.c"
	}
#line 122 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp31_ = item;
#line 122 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp32_ = key;
#line 122 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 122 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_set_data_full ((GObject*) _tmp31_, "toggle-list-key", _tmp33_, g_free);
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	result = (GtkButton*) item;
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_object_unref0 (label);
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_free0 (name);
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_object_unref0 (hbox);
#line 123 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return result;
#line 632 "toggle-box.c"
}


static void toggle_box_button_clicked_cb (ToggleBox* self, GtkButton* button) {
	GtkButton* _tmp0_;
	gconstpointer _tmp1_;
#line 126 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 126 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (button != NULL);
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = button;
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp1_ = g_object_get_data ((GObject*) _tmp0_, "toggle-list-key");
#line 128 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	toggle_box_set_selected_key (self, (const gchar*) _tmp1_);
#line 649 "toggle-box.c"
}


static void toggle_box_real_grab_focus (GtkWidget* base) {
	ToggleBox * self;
	GtkButton* _tmp0_;
#line 131 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self = (ToggleBox*) base;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = self->priv->selected_button;
#line 133 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (_tmp0_ != NULL) {
#line 662 "toggle-box.c"
		GtkButton* _tmp1_;
#line 134 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp1_ = self->priv->selected_button;
#line 134 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 668 "toggle-box.c"
	}
}


const gchar* toggle_box_get_default_key (ToggleBox* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = self->priv->_default_key;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return result;
#line 684 "toggle-box.c"
}


static void toggle_box_set_default_key (ToggleBox* self, const gchar* value) {
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_default_key (self)) != 0) {
#line 693 "toggle-box.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp0_ = value;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_free0 (self->priv->_default_key);
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		self->priv->_default_key = _tmp1_;
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_object_notify ((GObject *) self, "default-key");
#line 706 "toggle-box.c"
	}
}


const gchar* toggle_box_get_starting_key (ToggleBox* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = self->priv->_starting_key;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	result = _tmp0_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return result;
#line 722 "toggle-box.c"
}


static void toggle_box_set_starting_key (ToggleBox* self, const gchar* value) {
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_starting_key (self)) != 0) {
#line 731 "toggle-box.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp0_ = value;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_free0 (self->priv->_starting_key);
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		self->priv->_starting_key = _tmp1_;
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_object_notify ((GObject *) self, "starting-key");
#line 744 "toggle-box.c"
	}
}


const gchar* toggle_box_get_selected_key (ToggleBox* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_tmp0_ = self->priv->_selected_key;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	result = _tmp0_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return result;
#line 760 "toggle-box.c"
}


void toggle_box_set_selected_key (ToggleBox* self, const gchar* value) {
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	if (g_strcmp0 (value, toggle_box_get_selected_key (self)) != 0) {
#line 769 "toggle-box.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp0_ = value;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		_g_free0 (self->priv->_selected_key);
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		self->priv->_selected_key = _tmp1_;
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_object_notify ((GObject *) self, "selected-key");
#line 782 "toggle-box.c"
	}
}


static GObject * toggle_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ToggleBox * self;
#line 47 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	parent_class = G_OBJECT_CLASS (toggle_box_parent_class);
#line 47 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOGGLE_BOX, ToggleBox);
#line 49 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 47 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	return obj;
#line 801 "toggle-box.c"
}


static void toggle_box_class_init (ToggleBoxClass * klass) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	toggle_box_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_type_class_add_private (klass, sizeof (ToggleBoxPrivate));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) toggle_box_real_draw;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	((GtkWidgetClass *) klass)->grab_focus = (void (*) (GtkWidget *)) toggle_box_real_grab_focus;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_toggle_box_get_property;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_toggle_box_set_property;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->constructor = toggle_box_constructor;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	G_OBJECT_CLASS (klass)->finalize = toggle_box_finalize;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_DEFAULT_KEY, g_param_spec_string ("default-key", "default-key", "default-key", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_STARTING_KEY, g_param_spec_string ("starting-key", "starting-key", "starting-key", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_BOX_SELECTED_KEY, g_param_spec_string ("selected-key", "selected-key", "selected-key", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 828 "toggle-box.c"
}


static void toggle_box_instance_init (ToggleBox * self) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self->priv = TOGGLE_BOX_GET_PRIVATE (self);
#line 835 "toggle-box.c"
}


static void toggle_box_finalize (GObject * obj) {
	ToggleBox * self;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOGGLE_BOX, ToggleBox);
#line 22 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_free0 (self->priv->_default_key);
#line 23 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_free0 (self->priv->_starting_key);
#line 24 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_free0 (self->priv->_selected_key);
#line 45 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	_g_object_unref0 (self->priv->selected_button);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	G_OBJECT_CLASS (toggle_box_parent_class)->finalize (obj);
#line 853 "toggle-box.c"
}


GType toggle_box_get_type (void) {
	static volatile gsize toggle_box_type_id__volatile = 0;
	if (g_once_init_enter (&toggle_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ToggleBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) toggle_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ToggleBox), 0, (GInstanceInitFunc) toggle_box_instance_init, NULL };
		GType toggle_box_type_id;
		toggle_box_type_id = g_type_register_static (gtk_box_get_type (), "ToggleBox", &g_define_type_info, 0);
		g_once_init_leave (&toggle_box_type_id__volatile, toggle_box_type_id);
	}
	return toggle_box_type_id__volatile;
}


static void _vala_toggle_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ToggleBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOGGLE_BOX, ToggleBox);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_DEFAULT_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_default_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_STARTING_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_starting_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_SELECTED_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		g_value_set_string (value, toggle_box_get_selected_key (self));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 892 "toggle-box.c"
		default:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 898 "toggle-box.c"
	}
}


static void _vala_toggle_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ToggleBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOGGLE_BOX, ToggleBox);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_DEFAULT_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		toggle_box_set_default_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_STARTING_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		toggle_box_set_starting_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		case TOGGLE_BOX_SELECTED_KEY:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		toggle_box_set_selected_key (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 926 "toggle-box.c"
		default:
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/slick-greeter-1.0.7/src/toggle-box.vala"
		break;
#line 932 "toggle-box.c"
	}
}



